



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java集合框架（三）—— List、ArrayList、Vector、Stack</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java集合框架（三）—— List、ArrayList、Vector、Stack</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 13:08:37 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li><h3>List接口</h3></li></ul>
<p>　　<strong>List集合</strong>代表一个<strong>有序集合</strong>，集合中每一个<strong>元素都有其对应的顺序索引</strong>。List集合<strong>容许使用重复元素</strong>，<strong>可以通过索引来访问指定位置的集合对象。</strong></p>
<ul><li><h4>ArrayList和Vector实现类</h4></li></ul>
<p>　　<strong>ArrayList和Vector</strong>做为List的类的两个典型实现，完全支持list集合的全部功能。</p>
<p>　　<strong>ArrayList和Vector类都是基于数组实现的List类</strong>，所以ArrayList和Vector类<strong>封装了一个动态再分配的Object[]数组</strong>。每个ArrayList或Vector对象有一个<strong>capacity属性</strong>，这个capacity表示它们所封装的Object[]数组的长度。<strong>当向ArrayList或Vector中添加元素时，它们的capacity会自动增加。</strong></p>
<p>　　对于通常编程场景，程序员无须关心ArrayList或Vector的capacity属性。<strong>但如果向ArrayList集合或Vector集合中添加大量元素时，可使用ensureCapacity方法一次性地增加capacity。这可以减少增加重分配的次数，从而提高性能。</strong></p>
<p>　　如果开始就知道ArrayList或Vector需要保存多少个元素，则可以在创建该它们时就指定它们的capacity大小。如果创建空的ArrayList和Vector时不指定capacity属性，<strong>该属性默认为10</strong>。</p>
<p>　　除此之外，ArrayList和Vector还提供了如下两个方法来操作capacity属性：</p>
<p>　　　　void ensureCapacity(int minCapacity);&nbsp; 将ArrayList或Vector集合的capacity增加minCapacity。</p>
<p>　　　　void trimToSize(); &nbsp; 调整ArrayList或Vector集合的capacity为列表当前大小。程序可调用该方法来减少ArrayList或Vector集合对象存储空间。</p>
<p>　　<strong>ArrayList和Vector在用法上几乎完全相同</strong>，但由于Vector是一个古老的集合(从JDK1.0就有了)，最开始的时候，Java没有提供系统的集合框架，所以Vector里面提供一些方法名很长的方法：例如addElement(Object obj);实际上这个方法与add(Object obj)没有任何区别。从JDK1.2之后，Java提供了系统的集合框架，就将Vector改为实现List接口，做为List的实现之一，从而导致Vector里面有一些功能重复的方法。</p>
<p>　　除此之外，<strong>ArrayList和Vector的显著区别是</strong>；<strong>ArrayList是线程不安全的</strong>，当多条线程访问同一个ArrayList集合时，如果有超过一条线程修改了ArrayList集合，则程序必须受到保证该集合的同步性。但<strong>Vector是线程安全的</strong>，无须程序保证该集合的同步性。<strong>因为Vector是线程安全的，所以Vector的性能要比ArrayList的效率要低。</strong>实际上即使需要保证list集合线程安全，同样不推荐使用Vector实现类，而是使用Collections工具类，它可以将一个ArrayList变的线程安全。</p>
<p>　　Vector还提供了一个<strong>Stack</strong>子类，它用于模拟了&ldquo;<strong>栈</strong>&rdquo;这种数据结构，&ldquo;栈&rdquo;通常是指&ldquo;后进先出&rdquo;的容器。最后&ldquo;push&rdquo;进栈的元素，将最先被&ldquo;pop&rdquo;出栈。与Java中其他集合一样，进栈出栈的都是Object。</p>
<p>　　　　Object peek();&nbsp;&nbsp; //返回&ldquo;栈&rdquo;的第一个元素，但并不将该元素&ldquo;pop&rdquo;出栈。</p>
<p>　　　　Object pop();&nbsp;&nbsp;&nbsp; //返回&ldquo;栈&rdquo;的第一个元素，并将该元素&ldquo;pop&rdquo;出栈。</p>
<p>　　　　void push(Object obj);&nbsp;&nbsp;&nbsp; //将一个元素&ldquo;push&rdquo;进栈，最后一个进&ldquo;栈&rdquo;的元素总是位于&ldquo;栈&rdquo;顶。</p>
<div>
<pre class="prettyprint linenums">public class Test {<br />
    public static void main(String[] args){<br />
        Stack&lt;Integer&gt; s = new Stack&lt;Integer&gt;();<br />
        s.push(6);<br />
        s.push(5);<br />
        s.push(4);<br />
        //输出:[6, 5, 4]<br />
        System.out.println(s);<br />
        //访问第一个元素，但并不将其pop出栈，输出:4<br />
        System.out.println(s.peek());<br />
        //pop出第一个元素，输出：4<br />
        System.out.println(s.pop());<br />
        //输出: [6, 5]<br />
        System.out.println(s);<br />
    }<br />
}</pre>
</div>
<ul><li><h4>固定长度的List</h4></li></ul>
<p>　　我们知道有一个<strong>操作数组的工具类</strong>：<strong>Arrays</strong>，该工具类里提供了<strong>asList(Object...&nbsp; a)方法</strong>，该方法可以把一个数组或指定个数的对象转换成一个List集合，这个List集合既不是ArrayList实现类的实例，也不是Vector实现类的实例，<strong>而是Arrays的内部类ArrayList的实例</strong>。</p>
<p>　　<strong>Arrays.ArrayList</strong>是一个<strong>固定长度的List集合</strong>，<strong>程序只能遍历访问该集合里的元素，不可增加、删除该集合里的元素</strong>。如下：</p>
<div>
<pre class="prettyprint linenums"> public class Test {<br />
    public static void main(String[] args){<br />
        String str[] = {"北京", "上海", "深圳"};<br />
        List&lt;String&gt; list = Arrays.asList(str);<br />
        for(String s : list){<br />
            System.out.println(s);<br />
        }<br />
        //以下两句都将引起错误java.lang.UnsupportedOperationException<br />
        list.add("南京");<br />
        list.remove(0);<br />
    }<br />
}</pre>
</div>
<p>　　上面最后两行代码对于普通List集合完全正常，但如果试图通过这两个方法来增加、删除Arrays.ArrayList集合里的元素，将会引发异常。所以上面代码在编译时完全正常，但在运行时抛出java.lang.UnsupportedOperationException异常。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1r4g48.html">intellij IDEA 出现&OpenCurlyDoubleQuote;Usage of API documented as &commat;since 1&period;6&plus;&rdquo;的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1p1k5q.html">我的第一个WebAPI程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyr57m8.html">Sprint1（第三天11&period;16）</a>
		</li>
						<li><a href="https://www.batexi.com/a/4957wlmq.html">JS魔法堂：mmDeferred源码剖析</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxr6nvq.html">BZOJ1146&mdash;&mdash;&lbrack;CTSC2008&rsqb;网络管理Network</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1r5yn9.html">一个小巧的C&plus;&plus;Log输出到文件类 （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ok4649.html">App页面显示优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zng1z9.html">Bzoj 1856&colon; &lbrack;Scoi2010&rsqb;字符串  卡特兰数&comma;乘法逆元&comma;组合数&comma;数论</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmdwnk9.html">为什么每个请求都要有用户名密码呢，那不是每次都要查询一下了，token，表示这个用户已经验证通过了，在token有效期内，只需要判断token是否有效就可以了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydz1vdq.html">AJAX上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x01en9.html">Node&period;js 小工具--supervisor</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yo11w8.html">Mysql 连接查询 Mysql支持的连接查询有哪些</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk2dkj8.html">浅谈JAVA中字符串常量的储存位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mew01oq.html">Hadoop和MapReduce初识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpryn79.html">MYSQL无法使用索引的场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpgdvr9.html">Eclipse的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyyp5n9.html">WebAssembly是解决JavaScript 痼疾的银弹？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy0jxv9.html">Java学习&mdash;&mdash;多线程例子：李四王五</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppm2e49.html">sencha touch 在线实战培训 第一期 第二节</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpd1mz9.html">30  进程process</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj00gj8.html">数据存储之Web存储（sessionStorage localStorage globalStorage ）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4zk59.html">Linux下passwd和shadow文件内容详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xjlxq.html">python--批量下载豆瓣图片之升级版本</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z3y5k9.html">使用Filebeat和Logstash集中归档日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pgeln8.html">canvas将图片转为base64</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpl2r7q.html">JAVA配置&amp;amp&semi;注解方式搭建简单的SpringMVC前后台交互系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj76ex9.html">python编码的那些事</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkx7ez8.html">c&num; 颜色RGB到HSB互相转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ml6338.html">ABP官方文档翻译 8&period;2 SignalR集成</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpl03r9.html">python爬虫（7）&mdash;&mdash;BeautifulSoup</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
